#ifndef __I2C400_H
#define __I2C400_H





#define 	Adr_Base	0x300	   	// Base adress for the board





#define 	I2CSTA		Adr_Base    // Status register adress
#define 	I2CTO		Adr_Base	// TimeOut register adress
#define 	I2CDAT		Adr_Base+1	// Data register
#define		I2CADR		Adr_Base+2	// Own adress register
#define		I2CCON		Adr_Base+3	// Control register

#define		Adr_Reset_0	Adr_Base+4	// This adress set the reset to 0
#define		Adr_Reset_1	Adr_Base+5	// This adress set the reset to 1








// I2C_Init : Initialise and configure the PCA9564
// Parameter Freq takes one of the following value :

#define 	Clock_Freq_330	0x00
#define 	Clock_Freq_288	0x01
#define 	Clock_Freq_217	0x02
#define 	Clock_Freq_146	0x03
#define 	Clock_Freq_88	0x04
#define 	Clock_Freq_59	0x05
#define 	Clock_Freq_44	0x06
#define 	Clock_Freq_36	0x07


// I2C_Config : set the parameters for the PCA6564
// Set the frequency

extern void I2C_Config(unsigned char Freq);


// The function return :
//  0 if the initialisation is successfull
// -1 if the state machine is not in the initial state after reset

extern int I2C_Init();





// I2C_Write : send a the byte Data at the adress Data on the I2C bus
//
// The function return :
//  0 if the transmission is successfull (2 acknoledges)
// -1 if the state machine is not in the initial state at the beginning of the function
// -2 transmission error while sending the START bit
// -3 no acknoledge after adress transmission, the line came back in the initial state
// -4 no acknoledge after adress transmission, the line didn't came back in the initial state
// -5 no acknoledge after adress transmission or another master took the line
// -6 transmission error while sending the START bitTransmitting the data
// -7 The state machine didn't return in the initial state after the sent of the stop bit

extern int I2C_Write(unsigned char Adress, unsigned char Data);




// I2C_Read : send a the byte Data at the adress Data on the I2C bus
//
// The function return :
//  0 if the transmission is successfull (2 acknoledges)
// -1 if the state machine is not in the initial state at the beginning of the function
// -2 transmission error while sending the START bit
// -3 no acknoledge after adress transmission, the line came back in the initial state
// -4 no acknoledge after adress transmission, the line didn't came back in the initial state
// -5 no acknoledge after adress transmission or another master took the line
// -6 transmission error while sending the START bitTransmitting the data
// -7 The state machine didn't return in the initial state after the sent of the stop bit


int I2C_Read(unsigned char Adress);


#endif



